-- name: [CS] Jujutsu Kaisen 64
-- description: The main cast of JJK joins Coop!
--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/blob/main/API-doc.md
]]

local E_MODEL_GOJO_MODEL = smlua_model_util_get_id("gojo_geo")

local TEXT_MOD_NAME = "Satoru Gojo"

local VOICETABLE_GOJO = {
    [CHAR_SOUND_ATTACKED] = 'confused.ogg',
	[CHAR_SOUND_EEUH] = 'neh.ogg',
	[CHAR_SOUND_LETS_A_GO] = 'voice_JJGJO_chance.ogg',
    [CHAR_SOUND_DROWNING] = 'confused.ogg',
    [CHAR_SOUND_DYING] = 'voice_JJGJO_lose.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'tuh.ogg',
    [CHAR_SOUND_HAHA] = 'voice_JJGJO_rensaFP06.ogg',
    [CHAR_SOUND_HAHA_2] = 'voice_JJGJO_damage1.ogg',
	[CHAR_SOUND_DOH] = 'tuh.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'voice_JJGJO_questclear.ogg',
    [CHAR_SOUND_HOOHOO] = 'kah.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'voice_JJGJO_zenkeshi.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'voice_JJGJO_finish01.ogg',
    [CHAR_SOUND_ON_FIRE] = 'confused.ogg',
    [CHAR_SOUND_OOOF] = 'confused.ogg',
    [CHAR_SOUND_OOOF2] = 'kah.ogg',
	[CHAR_SOUND_HRMM] = 'kah.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'ma.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'voice_JJGJO_finish01.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'voice_JJGJO_rensaFP07.ogg',
	[CHAR_SOUND_UH] = 'word.ogg',
    [CHAR_SOUND_UH2] = 'tuh.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'voice_JJGJO_rensaFP02.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'voice_JJGJO_rensaFP01.ogg',
    [CHAR_SOUND_WAAAOOOW] ='voice_JJGJO_rensaFP04.ogg',
    [CHAR_SOUND_WAH2] = 'neh.ogg',
    [CHAR_SOUND_WHOA] = 'voice_JJGJO_rensaFP04.ogg',
    [CHAR_SOUND_YAHOO] = 'tuh.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'ma.ogg', 'voice_JJGJO_finish01.ogg', 'voice_JJGJO_rensaFP07.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'ma.ogg', 'voice_JJGJO_finish01.ogg', 'voice_JJGJO_rensaFP07.ogg'},
}

if _G.charSelectExists then
    _G.charSelect.character_add("Satoru Gojo", {"Nah, I'd win."}, "eldritchmeat", {r = 109, g = 89, b = 146}, E_MODEL_GOJO_MODEL, CT_MARIO, get_texture_info("gojoicon"))

    _G.charSelect.character_add_voice(E_MODEL_GOJO_MODEL, VOICETABLE_GOJO)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_GOJO then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_GOJO then return _G.charSelect.voice.snore(m) end
    end)
else
    djui_popup_create("\\#a32317\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end


local E_MODEL_YUJI_MODEL = smlua_model_util_get_id("yuji_geo")

local TEXT_MOD_NAME = "Yuji Itadori"

local VOICETABLE_YUJI = {
    [CHAR_SOUND_ATTACKED] = 'voice_JJITA_damage1.ogg',
	[CHAR_SOUND_EEUH] = 'voice_JJITA_rensa09.ogg',
	[CHAR_SOUND_LETS_A_GO] = 'voice_JJITA_chance.ogg',
    [CHAR_SOUND_DROWNING] = 'voice_JJITA_lose.ogg',
    [CHAR_SOUND_DYING] = 'voice_JJITA_lose.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'voice_JJITA_finish01.ogg',
    [CHAR_SOUND_HAHA] = 'voice_JJITA_questclear.ogg',
    [CHAR_SOUND_HAHA_2] = 'voice_JJITA_rensa01.ogg',
	[CHAR_SOUND_DOH] = 'voice_JJITA_damage2.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'voice_JJITA_questclear.ogg',
    [CHAR_SOUND_HOOHOO] = 'voice_JJITA_rensa10.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'voice_JJITA_zenkeshi.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'voice_JJITA_rensa06.ogg',
    [CHAR_SOUND_ON_FIRE] = 'voice_JJITA_damage1.ogg',
    [CHAR_SOUND_OOOF] = 'voice_JJITA_damage1.ogg',
    [CHAR_SOUND_OOOF2] = 'voice_JJITA_rensa09.ogg',
	[CHAR_SOUND_HRMM] = 'voice_JJITA_rensa02.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'voice_JJITA_rensa04.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'voice_JJITA_rensa08.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'voice_JJITA_finish02.ogg',
	[CHAR_SOUND_UH] = 'voice_JJITA_rensa04.ogg',
    [CHAR_SOUND_UH2] = 'voice_JJITA_damage1.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'voice_JJITA_skill1.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'voice_JJITA_chance.ogg',
    [CHAR_SOUND_WAAAOOOW] ='voice_JJITA_damage1.ogg',
    [CHAR_SOUND_WAH2] = 'voice_JJITA_rensa05.ogg',
    [CHAR_SOUND_WHOA] = 'voice_JJITA_damage2.ogg',
    [CHAR_SOUND_YAHOO] = 'voice_JJITA_rensa04.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'voice_JJITA_rensa04.ogg', 'voice_JJITA_rensa08.ogg', 'voice_JJITA_finish02.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'voice_JJITA_rensa04.ogg', 'voice_JJITA_rensa08.ogg', 'voice_JJITA_finish02.ogg'},
}

if _G.charSelectExists then
    _G.charSelect.character_add("Yuji Itadori", {"I don't want to regret the way I lived."}, "eldritchmeat", {r = 202, g = 58, b = 58}, E_MODEL_YUJI_MODEL, CT_MARIO, get_texture_info("yujiicon"))

    _G.charSelect.character_add_voice(E_MODEL_YUJI_MODEL, VOICETABLE_YUJI)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_YUJI then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_YUJI then return _G.charSelect.voice.snore(m) end
    end)
else
    djui_popup_create("\\#a32317\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end


local E_MODEL_NOBARA_MODEL = smlua_model_util_get_id("nobara_geo")

local TEXT_MOD_NAME = "Nobara Kugisaki"

local VOICETABLE_NOBARA = {
    [CHAR_SOUND_ATTACKED] = 'nobarahurt.ogg',
	[CHAR_SOUND_EEUH] = 'voice_JJKUG_rensa07.ogg',
	[CHAR_SOUND_LETS_A_GO] = 'voice_JJKUG_finish02.ogg',
    [CHAR_SOUND_DROWNING] = 'voice_JJKUG_lose.ogg',
    [CHAR_SOUND_DYING] = 'voice_JJKUG_lose.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'voice_JJKUG_rensa10.ogg',
    [CHAR_SOUND_HAHA] = 'voice_JJKUG_rensa04.ogg',
    [CHAR_SOUND_HAHA_2] = 'voice_JJKUG_rensa01.ogg',
	[CHAR_SOUND_DOH] = 'voice_JJKUG_damage1.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'voice_JJKUG_questclear.ogg',
    [CHAR_SOUND_HOOHOO] = 'voice_JJKUG_rensa06.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'voice_JJKUG_zenkeshi.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'voice_JJKUG_chance.ogg',
    [CHAR_SOUND_ON_FIRE] = 'nobarahurt.ogg',
    [CHAR_SOUND_OOOF] = 'voice_JJKUG_finish01.ogg',
    [CHAR_SOUND_OOOF2] = 'voice_JJKUG_rensa09.ogg',
	[CHAR_SOUND_HRMM] = 'voice_JJKUG_rensa02.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'voice_JJKUG_rensa10.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'voice_JJKUG_rensa09.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'voice_JJKUG_finish01.ogg',
	[CHAR_SOUND_UH] = 'voice_JJKUG_rensa03.ogg',
    [CHAR_SOUND_UH2] = 'voice_JJKUG_rensa08.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'voice_JJKUG_finish01.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'voice_JJKUG_rensa05.ogg',
    [CHAR_SOUND_WAAAOOOW] ='nobarahurt.ogg',
    [CHAR_SOUND_WAH2] = 'voice_JJKUG_rensa05.ogg',
    [CHAR_SOUND_WHOA] = 'voice_JJKUG_rensa08.ogg',
    [CHAR_SOUND_YAHOO] = 'voice_JJKUG_rensa07.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'voice_JJKUG_rensa10.ogg', 'voice_JJKUG_rensa09.ogg', 'voice_JJKUG_finish01.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'voice_JJKUG_rensa10.ogg', 'voice_JJKUG_rensa09.ogg', 'voice_JJKUG_finish01.ogg'},
}

if _G.charSelectExists then
    _G.charSelect.character_add("Nobara Kugisaki", {"It wasn't so bad!"}, "eldritchmeat", {r = 224, g = 131, b = 133}, E_MODEL_NOBARA_MODEL, CT_MARIO, get_texture_info("nobaraicon"))

    _G.charSelect.character_add_voice(E_MODEL_NOBARA_MODEL, VOICETABLE_NOBARA)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_NOBARA then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_NOBARA then return _G.charSelect.voice.snore(m) end
    end)
else
    djui_popup_create("\\#a32317\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end


local E_MODEL_MEGUMIJJK_MODEL = smlua_model_util_get_id("megumijjk_geo")

local TEXT_MOD_NAME = "Megumi Fushiguro"

local VOICETABLE_MEGUMIJJK = {
    [CHAR_SOUND_ATTACKED] = 'voice_JJFUS_damage1.ogg',
	[CHAR_SOUND_EEUH] = 'voice_JJFUS_rensa07.ogg',
	[CHAR_SOUND_LETS_A_GO] = 'voice_JJFUS_chance.ogg',
    [CHAR_SOUND_DROWNING] = 'voice_JJFUS_lose.ogg',
    [CHAR_SOUND_DYING] = 'voice_JJFUS_lose.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'voice_JJFUS_rensa10.ogg',
    [CHAR_SOUND_HAHA] = 'voice_JJFUS_rensa04.ogg',
    [CHAR_SOUND_HAHA_2] = 'voice_JJFUS_rensa01.ogg',
	[CHAR_SOUND_DOH] = 'voice_JJFUS_damage2.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'voice_JJFUS_questclear.ogg',
    [CHAR_SOUND_HOOHOO] = 'voice_JJFUS_rensa06.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'voice_JJFUS_zenkeshi.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'voice_JJFUS_chance.ogg',
    [CHAR_SOUND_ON_FIRE] = 'voice_JJFUS_damage2.ogg',
    [CHAR_SOUND_OOOF] = 'voice_JJFUS_damage2.ogg',
    [CHAR_SOUND_OOOF2] = 'voice_JJFUS_rensa09.ogg',
	[CHAR_SOUND_HRMM] = 'voice_JJFUS_rensa02.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'voice_JJFUS_rensa10.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'voice_JJFUS_rensa09.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'voice_JJFUS_rensa08.ogg',
	[CHAR_SOUND_UH] = 'voice_JJFUS_rensa03.ogg',
    [CHAR_SOUND_UH2] = 'voice_JJFUS_rensa08.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'voice_JJFUS_finish01.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'voice_JJFUS_rensa05.ogg',
    [CHAR_SOUND_WAAAOOOW] ='voice_JJFUS_damage1.ogg',
    [CHAR_SOUND_WAH2] = 'voice_JJFUS_rensa05.ogg',
    [CHAR_SOUND_WHOA] = 'voice_JJFUS_rensa08.ogg',
    [CHAR_SOUND_YAHOO] = 'voice_JJFUS_rensa07.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'voice_JJFUS_rensa10.ogg', 'voice_JJFUS_rensa09.ogg', 'voice_JJFUS_rensa08.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'voice_JJFUS_rensa10.ogg', 'voice_JJFUS_rensa09.ogg', 'voice_JJFUS_rensa08.ogg'},
}

if _G.charSelectExists then
    _G.charSelect.character_add("Megumi Fushiguro", {"Start by saving me, Itadori."}, "eldritchmeat", {r = 67, g = 78, b = 112}, E_MODEL_MEGUMIJJK_MODEL, CT_MARIO, get_texture_info("megumiicon"))

    _G.charSelect.character_add_voice(E_MODEL_MEGUMIJJK_MODEL, VOICETABLE_MEGUMIJJK)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_MEGUMIJJK then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_MEGUMIJJK then return _G.charSelect.voice.snore(m) end
    end)
else
    djui_popup_create("\\#a32317\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end